Add "apply on double-click" feature to most other recent ported KCMs
AbandonedPublic

Authored by ngraham on Jan 27 2019, 10:34 PM.

Details

Reviewers
broulik
ndavis
mart
Group Reviewers
VDG
Plasma
Summary

The new Colors KCM includes the "apply on double-click" feature requested in https://bugs.kde.org/show_bug.cgi?id=398303.

This patch adds that feature to other recently ported KCMs, except for the Look And Feel KCM, where there is still an unanswered question regarding how to handle the destructive checkbox.

Test Plan

Double-click on the items in the Icons, Plasma Theme, Cursors, and Splash Screen KCMs. The new setting is instantly applied.

CCBUG: 398303

Diff Detail

Repository
R119 Plasma Desktop
Branch
new-kcms-apply-on-double-click (branched from Plasma/5.15)
Lint
No Linters Available
Unit
No Unit Test Coverage
Build Status
Buildable 7603
Build 7621: arc lint + arc unit
ngraham created this revision.Jan 27 2019, 10:34 PM
Restricted Application added a project: Plasma. · View Herald TranscriptJan 27 2019, 10:34 PM
Restricted Application added a subscriber: plasma-devel. · View Herald Transcript
ngraham requested review of this revision.Jan 27 2019, 10:34 PM
ndavis accepted this revision.Jan 28 2019, 1:21 AM
ndavis added a subscriber: ndavis.

+1 to this. It's nice when you already know what you're doing and want to change a setting quickly.

This revision is now accepted and ready to land.Jan 28 2019, 1:21 AM

We should definitely be consistent. So either this or removing it from colours.

Personally I don't like it, we don't use double click anywhere else throughout all of Plasma, and given there's no visual hint upfront from a user POV it's random behaviour.

One of the things I loved about macOS when I was a user was how many little hidden accelerators like this were sprinkled throughout the OS. You don't find them unless you go looking, but once you've found them, they're indispensable. There was a whole website I used to follow back in the day to learn about even more of them: https://hints.macworld.com/

I don't think this would be too non-discoverable anyway; I was actually surprised that a double-click didn't function this way the first time I tried it. Double-click on a grid element to select + apply seems fairly natural to me at least.

One of the things I loved about macOS when I was a user was how many little hidden accelerators like this were sprinkled throughout the OS. You don't find them unless you go looking, but once you've found them, they're indispensable. There was a whole website I used to follow back in the day to learn about even more of them: https://hints.macworld.com/

I don't think this would be too non-discoverable anyway; I was actually surprised that a double-click didn't function this way the first time I tried it. Double-click on a grid element to select + apply seems fairly natural to me at least.

I think having some hidden, non-essential features that speed things up here and there is not a bad idea. It's not an objective reason, but I think a lot of people enjoy finding features like these. It turns the software into something to be mastered while still appearing simple at first. One of my favorite pieces of software, FL Studio, is absolutely littered with these kinds of features (perhaps going too far with it) and everyone who uses it loves sharing tips and tricks and finding new ones. It helps bring FL Studio users together and makes them more proud of being FL Studio users.

I think having some hidden, non-essential features that speed things up here and there is not a bad idea. It's not an objective reason, but I think a lot of people enjoy finding features like these. It turns the software into something to be mastered while still appearing simple at first. One of my favorite pieces of software, FL Studio, is absolutely littered with these kinds of features (perhaps going too far with it) and everyone who uses it loves sharing tips and tricks and finding new ones. It helps bring FL Studio users together and makes them more proud of being FL Studio users.

Yep. macOS used to be the same way. It becomes a point of pride, and a way for expert users to increase their expertise and bring other users in their circle of friends up to speed.

pino added a subscriber: pino.Jan 29 2019, 5:45 AM

-1 for this:

  • hidden feature
  • it does not make sense when the general paradigm is OK/Apply/Cancel, so we are teaching users that options are applied only when OK/Apply is pressed (and thus they are left free to play with options as they fit)
  • if an user accidentally double-clicks, then the options are saved a) against the user choice b) with no feedback at all
mart requested changes to this revision.Feb 11 2019, 9:52 AM
mart added a subscriber: mart.

if this is going to be used, it should be in the base component (where you can safely assume that kcm.save will exist) and have it as mandatory for every kcm

This revision now requires changes to proceed.Feb 11 2019, 9:52 AM
mart added a comment.Feb 11 2019, 9:53 AM

also, as the principle of the feature i agree with Pino
I don't recall any non instant apply dialog anywhere which becomes magically instant apply on doubleclick

That's true, this would be new and unprecedented. But it that necessarily a bad thing? It's just a hidden accelerator, that's all. It feels very natural to me, and IMO it's far nicer than having to click the Apply button after selecting a new style/theme/wallpaper/whatever. That awkward workflow is one of my biggest pet peeves with System Settings.

Maybe this patch isn't the best way to fix that, but in that case I'd like to start a conversation regarding how we do fix it, because it's a real problem. We are now the last people not using the "Instant Apply" paradigm. While it's not so bad in most places, I find it really awkward and unwelcome in these grid view KCMs.

We remain in a situation where the Colors KCM has this feature, but none of the others do. I really like having it as a hidden accelerator there, and I miss it in the other KCMs. I think we need to implement this everywhere, or remove it from the Colors KCM. But honestly I don't really see what we would gain if we did that.

ngraham abandoned this revision.Wed, Jun 26, 11:24 AM

Per @mart's suggestion, I've implemented this in the base item itself so it doesn't need to be done individually for every KCM. See D22102.

pino added a comment.Wed, Jun 26, 6:49 PM

I think we need to implement this everywhere, or remove it from the Colors KCM.

Indeed, this misfeature ought to be removed from the colors kcm for the reasons stated above.